﻿/**

History:
	$(HIST_VER 1.00β16,
		$(HIST_NEW)
	)
*/
module etc.negui.com.imalloc;

debug import std.stdio: wl = writefln;
debug(imalloc) void main() {}

import std.contracts;

public static import shlobj=win32.shlobj;
import win32.wtypes;

import etc.negui.system.text;
//import nemuxi.system.text;
//import nemuxi.system.nemuxierrors;
import etc.negui.system.exception;
import etc.negui.com.com;


extern(C) {
	CLSID IID_IMalloc= {0x00000002, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
}

///
interface IMalloc: IUnknown {
	void* Alloc(size_t);
	void* Realloc(void*, size_t);
	void Free(void*);
	size_t GetSize(void*);
	int DidAlloc(void*);
	void HeapMinimize();
}

///
class MallocException: ComException {
	mixin MixInNeGuiException;
}

/***/
class Malloc: Com!(IMalloc) {
	///
	this() {
		auto res=shlobj.SHGetMalloc(cast(shlobj.IMalloc*)&Known);
		enforce(res == NOERROR, new MallocException(Text("res != NOERROR")));
		super(true);
	}

	/**
	なんとなく。
	*/
	void free(void* p) {
		Known.Free(p);
	}
}


