﻿/**
数値のちまちま。

std.math使うまでもないようなしょうもないこと。
内部では使ってるけどね。
*/
module etc.negui.system.utility.number;

debug import std.stdio: wl = writefln;
debug(number) void main() {}

import std.math;
import std.traits;

/**
整数の桁数を取得。

Params:
	Num = 桁数を取得したい数。

Returns:
	桁数。

Examples:
	* ----------------------------------------
	* assert(GetDigits(0) == 1);
	* assert(GetDigits(1) == 1);
	* assert(GetDigits(10) == 2);
	* assert(GetDigits(-10) == 2);
	* ----------------------------------------
*/
size_t GetDigits(T)(T Num)
if(isIntegral!(T))
{
	if(Num >= 0) {
		return cast(size_t)log10(Num) + 1;
	} else {
		return cast(size_t)log10(-Num) + 1;
	}
}
debug(number) unittest {
	assert(GetDigits(0) == 1);
	assert(GetDigits(1) == 1);
	assert(GetDigits(10) == 2);
	assert(GetDigits(-10) == 2);
}




///
uint LOLONG(ulong l) {
	return cast(uint)l;
}
///
uint HILONG(ulong l) {
	return cast(uint)(l >>> 32);
}
///
ulong MAKEQWORD(uint low, uint hi) {
	return cast(ulong)((hi << 32) | low);
}




