﻿/**
UNLHA32.DLLラッパー。



*/
module etc.negui.wrapper.commonarchivers.header;

debug import etc.negui.nestdio: wl = writefln;
debug(header) void main() {}

import win32.windows;
/+
import etc.negui.system.base;
import etc.negui.wrapper.wrapper;
import etc.negui.wrapper.commonarchivers.commonarchivers;
+/


enum FNAME_MAX32 = 512;

struct ULHA_INT64 {
	DWORD	LowPart;
	LONG	HighPart;
}
alias ULHA_INT64* LPULHA_INT64;

typedef	HGLOBAL	HARC;

struct INDIVIDUALINFOA {
	DWORD 			dwOriginalSize;		/* ファイルのサイズ */
 	DWORD 			dwCompressedSize;	/* 圧縮後のサイズ */
	DWORD			dwCRC;				/* 格納ファイルのチェックサム */
	UINT			uFlag;				/* 処理結果 */
										/* Status flag */
	UINT			uOSType;			/* 書庫作成に使われた OS */
	WORD			wRatio;				/* 圧縮率 */
	WORD			wDate;				/* 格納ファイルの日付(DOS 形式) */
	WORD 			wTime;				/* 格納ファイルの時刻(〃) */
	char			szFileName[FNAME_MAX32 + 1];	/* 格納ファイル名 */
	char			dummy1[3];
	char			szAttribute[8];		/* 格納ファイルの属性(書庫固有) */
	char			szMode[8];			/* 格納ファイルの格納モード(〃) */
}
alias INDIVIDUALINFOA* LPINDIVIDUALINFOA;
struct INDIVIDUALINFOW {
	DWORD 			dwOriginalSize;		/* ファイルのサイズ */
 	DWORD 			dwCompressedSize;	/* 圧縮後のサイズ */
	DWORD			dwCRC;				/* 格納ファイルのチェックサム */
	UINT			uFlag;				/* 処理結果 */
										/* Status flag */
	UINT			uOSType;			/* 書庫作成に使われた OS */
	WORD			wRatio;				/* 圧縮率 */
	WORD			wDate;				/* 格納ファイルの日付(DOS 形式) */
	WORD 			wTime;				/* 格納ファイルの時刻(〃) */
	WCHAR			szFileName[FNAME_MAX32 + 1];	/* 格納ファイル名 */
	WCHAR			dummy1[3];
	WCHAR			szAttribute[8];		/* 格納ファイルの属性(書庫固有) */
	WCHAR			szMode[8];			/* 格納ファイルの格納モード(〃) */
}
alias INDIVIDUALINFOW* LPINDIVIDUALINFOW;

version(Unicode) {
	alias INDIVIDUALINFOW   INDIVIDUALINFO;
	alias LPINDIVIDUALINFOW LPINDIVIDUALINFO;
} else {
	alias INDIVIDUALINFOA   INDIVIDUALINFO;
	alias LPINDIVIDUALINFOA LPINDIVIDUALINFO;
}

struct EXTRACTINGINFOA {
	DWORD 			dwFileSize;		/* 格納ファイルのサイズ */
	DWORD			dwWriteSize;	/* 書き込みサイズ */
	char			szSourceFileName[FNAME_MAX32 + 1];	/* 格納ファイル名 */
	char			dummy1[3];
	char			szDestFileName[FNAME_MAX32 + 1];
									/* 解凍先または圧縮元パス名 */
	char			dummy[3];
}
alias EXTRACTINGINFOA* LPEXTRACTINGINFOA;
struct EXTRACTINGINFOW {
	DWORD 			dwFileSize;		/* 格納ファイルのサイズ */
	DWORD			dwWriteSize;	/* 書き込みサイズ */
	WCHAR			szSourceFileName[FNAME_MAX32 + 1];	/* 格納ファイル名 */
	WCHAR			dummy1[3];
	WCHAR			szDestFileName[FNAME_MAX32 + 1];
									/* 解凍先または圧縮元パス名 */
	WCHAR			dummy[3];
}
alias EXTRACTINGINFOA* LPEXTRACTINGINFOW;

version(Unicode) {
	alias EXTRACTINGINFOA   EXTRACTINGINFO;
	alias LPEXTRACTINGINFOA LPEXTRACTINGINFO;
} else {
	alias EXTRACTINGINFOW   EXTRACTINGINFO;
	alias LPEXTRACTINGINFOW LPEXTRACTINGINFO;
}


struct EXTRACTINGINFOEXA{
	EXTRACTINGINFOA		exinfo;
	DWORD				dwCompressedSize;
	DWORD				dwCRC;
	UINT				uOSType;
	WORD				wRatio;
	WORD				wDate;
	WORD				wTime;
	char				szAttribute[8];
	char				szMode[8];
}
alias EXTRACTINGINFOEXA* LPEXTRACTINGINFOEXA;
struct EXTRACTINGINFOEXW {
	EXTRACTINGINFOW		exinfo;
	DWORD				dwCompressedSize;
	DWORD				dwCRC;
	UINT				uOSType;
	WORD				wRatio;
	WORD				wDate;
	WORD				wTime;
	WCHAR				szAttribute[8];
	WCHAR				szMode[8];
}
alias EXTRACTINGINFOEXW* LPEXTRACTINGINFOEXW;

version(Unicode) {
	alias EXTRACTINGINFOEXA   EXTRACTINGINFOEX;
	alias LPEXTRACTINGINFOEXA LPEXTRACTINGINFOEX;
} else {
	alias EXTRACTINGINFOEXW   EXTRACTINGINFOEX;
	alias LPEXTRACTINGINFOEXW LPEXTRACTINGINFOEX;
}


struct EXTRACTINGINFOEX32A {
	DWORD				dwStructSize;
	EXTRACTINGINFOA		exinfo;
	DWORD				dwFileSize;			/* 格納ファイルのサイズ */
	DWORD				dwCompressedSize;
	DWORD				dwWriteSize;		/* 書き込みサイズ */
	DWORD				dwAttributes;
	DWORD 				dwCRC;
	UINT  				uOSType;
	WORD  				wRatio;
	FILETIME			ftCreateTime;
	FILETIME			ftAccessTime;
	FILETIME			ftWriteTime;
	char  				szMode[8];
	char				szSourceFileName[FNAME_MAX32 + 1];	/* 格納ファイル名 */
	char				dummy1[3];
	char				szDestFileName[FNAME_MAX32 + 1];
										/* 解凍先または圧縮元パス名 */
	char				dummy2[3];
}
alias EXTRACTINGINFOEX32A* LPEXTRACTINGINFOEX32A;
struct EXTRACTINGINFOEX32W {
	DWORD				dwStructSize;
	EXTRACTINGINFOW		exinfo;
	DWORD				dwFileSize;			/* 格納ファイルのサイズ */
	DWORD				dwCompressedSize;
	DWORD				dwWriteSize;		/* 書き込みサイズ */
	DWORD				dwAttributes;
	DWORD 				dwCRC;
	UINT  				uOSType;
	WORD  				wRatio;
	FILETIME			ftCreateTime;
	FILETIME			ftAccessTime;
	FILETIME			ftWriteTime;
	WCHAR  				szMode[8];
	WCHAR				szSourceFileName[FNAME_MAX32 + 1];	/* 格納ファイル名 */
	WCHAR				dummy1[3];
	WCHAR				szDestFileName[FNAME_MAX32 + 1];
										/* 解凍先または圧縮元パス名 */
	WCHAR				dummy2[3];
}
alias EXTRACTINGINFOEX32W *LPEXTRACTINGINFOEX32W;

version(Unicode) {
	alias EXTRACTINGINFOEX32A   EXTRACTINGINFOEX32;
	alias LPEXTRACTINGINFOEX32A LPEXTRACTINGINFOEX32;
} else {
	alias EXTRACTINGINFOEX32W   EXTRACTINGINFOEX32;
	alias LPEXTRACTINGINFOEX32W LPEXTRACTINGINFOEX32;
}

struct EXTRACTINGINFOEX64A {
	DWORD				dwStructSize;
	EXTRACTINGINFOA		exinfo;
	ULHA_INT64			llFileSize;			/* 格納ファイルのサイズ */
	ULHA_INT64			llCompressedSize;
	ULHA_INT64			llWriteSize;		/* 書き込みサイズ */
	DWORD				dwAttributes;
	DWORD 				dwCRC;
	UINT  				uOSType;
	WORD  				wRatio;
	FILETIME			ftCreateTime;
	FILETIME			ftAccessTime;
	FILETIME			ftWriteTime;
	char  				szMode[8];
	char				szSourceFileName[FNAME_MAX32 + 1];	/* 格納ファイル名 */
	char				dummy1[3];
	char				szDestFileName[FNAME_MAX32 + 1];
										/* 解凍先または圧縮元パス名 */
	char				dummy2[3];
}
alias  EXTRACTINGINFOEX64A* LPEXTRACTINGINFOEX64A;
struct EXTRACTINGINFOEX64W {
	DWORD				dwStructSize;
	EXTRACTINGINFOW		exinfo;
	ULHA_INT64			llFileSize;			/* 格納ファイルのサイズ */
	ULHA_INT64			llCompressedSize;
	ULHA_INT64			llWriteSize;		/* 書き込みサイズ */
	DWORD				dwAttributes;
	DWORD 				dwCRC;
	UINT  				uOSType;
	WORD  				wRatio;
	FILETIME			ftCreateTime;
	FILETIME			ftAccessTime;
	FILETIME			ftWriteTime;
	WCHAR  				szMode[8];
	WCHAR				szSourceFileName[FNAME_MAX32 + 1];	/* 格納ファイル名 */
	WCHAR				dummy1[3];
	WCHAR				szDestFileName[FNAME_MAX32 + 1];
										/* 解凍先または圧縮元パス名 */
	WCHAR				dummy2[3];
}
alias EXTRACTINGINFOEX64W* LPEXTRACTINGINFOEX64W;
version(Unicode) {
	alias EXTRACTINGINFOEX64A   EXTRACTINGINFOEX64;
	alias LPEXTRACTINGINFOEX64A LPEXTRACTINGINFOEX64;
} else {
	alias EXTRACTINGINFOEX64W   EXTRACTINGINFOEX64;
	alias LPEXTRACTINGINFOEX64W LPEXTRACTINGINFOEX64;
}

alias extern(Windows) BOOL function(HWND, UINT, UINT, LPVOID) ARCHIVERPROC;
alias ARCHIVERPROC* LPARCHIVERPROC;

struct UNLHA_ENUM_MEMBER_INFOA {
	DWORD			dwStructSize;
	UINT			uCommand;
	DWORD			dwOriginalSize;
	DWORD			dwCompressedSize;
	DWORD			dwAttributes;
	DWORD			dwCRC;
	UINT			uOSType;
	WORD			wRatio;
	FILETIME		ftCreateTime;
	FILETIME		ftAccessTime;
	FILETIME		ftWriteTime;
	char			szFileName[FNAME_MAX32 + 1];
	char			dummy1[3];
	char			szAddFileName[FNAME_MAX32 + 1];
	char			dummy2[3];
}
alias UNLHA_ENUM_MEMBER_INFOA* LPUNLHA_ENUM_MEMBER_INFOA;
struct UNLHA_ENUM_MEMBER_INFOW {
	DWORD			dwStructSize;
	UINT			uCommand;
	DWORD			dwOriginalSize;
	DWORD			dwCompressedSize;
	DWORD			dwAttributes;
	DWORD			dwCRC;
	UINT			uOSType;
	WORD			wRatio;
	FILETIME		ftCreateTime;
	FILETIME		ftAccessTime;
	FILETIME		ftWriteTime;
	WCHAR			szFileName[FNAME_MAX32 + 1];
	WCHAR			dummy1[3];
	WCHAR			szAddFileName[FNAME_MAX32 + 1];
	WCHAR			dummy2[3];
}
alias UNLHA_ENUM_MEMBER_INFOW* LPUNLHA_ENUM_MEMBER_INFOW;
version(Unicode) {
	alias UNLHA_ENUM_MEMBER_INFOA   UNLHA_ENUM_MEMBER_INFO;
	alias LPUNLHA_ENUM_MEMBER_INFOA LPUNLHA_ENUM_MEMBER_INFO;
} else {
	alias UNLHA_ENUM_MEMBER_INFOW   UNLHA_ENUM_MEMBER_INFO;
	alias LPUNLHA_ENUM_MEMBER_INFOW LPUNLHA_ENUM_MEMBER_INFO;
}

struct UNLHA_ENUM_MEMBER_INFO64A {
	DWORD			dwStructSize;
	UINT			uCommand;
	ULHA_INT64		llOriginalSize;
	ULHA_INT64		llCompressedSize;
	DWORD			dwAttributes;
	DWORD			dwCRC;
	UINT			uOSType;
	WORD			wRatio;
	FILETIME		ftCreateTime;
	FILETIME		ftAccessTime;
	FILETIME		ftWriteTime;
	char			szFileName[FNAME_MAX32 + 1];
	char			dummy1[3];
	char			szAddFileName[FNAME_MAX32 + 1];
	char			dummy2[3];
}
alias UNLHA_ENUM_MEMBER_INFO64A* LPUNLHA_ENUM_MEMBER_INFO64A;
struct UNLHA_ENUM_MEMBER_INFO64W {
	DWORD			dwStructSize;
	UINT			uCommand;
	ULHA_INT64		llOriginalSize;
	ULHA_INT64		llCompressedSize;
	DWORD			dwAttributes;
	DWORD			dwCRC;
	UINT			uOSType;
	WORD			wRatio;
	FILETIME		ftCreateTime;
	FILETIME		ftAccessTime;
	FILETIME		ftWriteTime;
	WCHAR			szFileName[FNAME_MAX32 + 1];
	WCHAR			dummy1[3];
	WCHAR			szAddFileName[FNAME_MAX32 + 1];
	WCHAR			dummy2[3];
}
alias UNLHA_ENUM_MEMBER_INFO64W* LPUNLHA_ENUM_MEMBER_INFO64W;
version(Unicode) {
	alias UNLHA_ENUM_MEMBER_INFO64A   UNLHA_ENUM_MEMBER_INFO64;
	alias LPUNLHA_ENUM_MEMBER_INFO64A LPUNLHA_ENUM_MEMBER_INFO64;
} else {
	alias UNLHA_ENUM_MEMBER_INFO64W   UNLHA_ENUM_MEMBER_INFO64;
	alias LPUNLHA_ENUM_MEMBER_INFO64W LPUNLHA_ENUM_MEMBER_INFO64;
}

//typedef BOOL (CALLBACK *UNLHA_WND_ENUMMEMBPROC)(LPVOID);
alias extern(Windows) BOOL function(LPVOID) *UNLHA_WND_ENUMMEMBPROC;



enum {
	CHECKARCHIVE_RAPID = 0,

	CHECKARCHIVE_BASIC = 1,

	CHECKARCHIVE_FULLCRC = 2,
/* 以下のフラグは上記と組み合わせて使用。*/


	CHECKARCHIVE_RECOVERY = 4,

	CHECKARCHIVE_SFX = 8,

	CHECKARCHIVE_ALL = 16,



	UNPACK_CONFIG_MODE = 1,

	PACK_CONFIG_MODE = 2,



	ISARC_FUNCTION_START = 0,

	ISARC = 0,

	ISARC_GET_VERSION = 1,

	ISARC_GET_CURSOR_INTERVAL = 2,

	ISARC_SET_CURSOR_INTERVAL = 3,

	ISARC_GET_BACK_GROUND_MODE = 4,

	ISARC_SET_BACK_GROUND_MODE = 5,

	ISARC_GET_CURSOR_MODE = 6,

	ISARC_SET_CURSOR_MODE = 7,

	ISARC_GET_RUNNING = 8,


	ISARC_CHECK_ARCHIVE = 16,

	ISARC_CONFIG_DIALOG = 17,

	ISARC_GET_FILE_COUNT = 18,

	ISARC_QUERY_FUNCTION_LIST = 19,

	ISARC_HOUT = 20,

	ISARC_STRUCTOUT = 21,

	ISARC_GET_ARC_FILE_INFO = 22,


	ISARC_OPEN_ARCHIVE = 23,

	ISARC_CLOSE_ARCHIVE = 24,

	ISARC_FIND_FIRST = 25,

	ISARC_FIND_NEXT = 26,

	ISARC_EXTRACT = 27,

	ISARC_ADD = 28,

	ISARC_MOVE = 29,

	ISARC_DELETE = 30,

	ISARC_SETOWNERWINDOW = 31,

	ISARC_CLEAROWNERWINDOW = 32,

	ISARC_SETOWNERWINDOWEX = 33,

	ISARC_KILLOWNERWINDOWEX = 34,


	ISARC_GET_ARC_FILE_NAME = 40,

	ISARC_GET_ARC_FILE_SIZE = 41,

	ISARC_GET_ARC_ORIGINAL_SIZE = 42,

	ISARC_GET_ARC_COMPRESSED_SIZE = 43,

	ISARC_GET_ARC_RATIO = 44,

	ISARC_GET_ARC_DATE = 45,

	ISARC_GET_ARC_TIME = 46,

	ISARC_GET_ARC_OS_TYPE = 47,

	ISARC_GET_ARC_IS_SFX_FILE = 48,

	ISARC_GET_ARC_WRITE_TIME_EX = 49,

	ISARC_GET_ARC_CREATE_TIME_EX = 50,

	ISARC_GET_ARC_ACCESS_TIME_EX = 51,

	ISARC_GET_ARC_CREATE_TIME_EX2 = 52,

	ISARC_GET_ARC_WRITE_TIME_EX2 = 53,

	ISARC_GET_FILE_NAME = 57,

	ISARC_GET_ORIGINAL_SIZE = 58,

	ISARC_GET_COMPRESSED_SIZE = 59,

	ISARC_GET_RATIO = 60,

	ISARC_GET_DATE = 61,

	ISARC_GET_TIME = 62,

	ISARC_GET_CRC = 63,

	ISARC_GET_ATTRIBUTE = 64,

	ISARC_GET_OS_TYPE = 65,

	ISARC_GET_METHOD = 66,

	ISARC_GET_WRITE_TIME = 67,

	ISARC_GET_CREATE_TIME = 68,

	ISARC_GET_ACCESS_TIME = 69,

	ISARC_GET_WRITE_TIME_EX = 70,

	ISARC_GET_CREATE_TIME_EX = 71,

	ISARC_GET_ACCESS_TIME_EX = 72,

	ISARC_SET_ENUM_MEMBERS_PROC = 80,

	ISARC_CLEAR_ENUM_MEMBERS_PROC = 81,

	ISARC_GET_ARC_FILE_SIZE_EX = 82,

	ISARC_GET_ARC_ORIGINAL_SIZE_EX = 83,

	ISARC_GET_ARC_COMPRESSED_SIZE_EX = 84,

	ISARC_GET_ORIGINAL_SIZE_EX = 85,

	ISARC_GET_COMPRESSED_SIZE_EX = 86,

	ISARC_SETOWNERWINDOWEX64 = 87,

	ISARC_KILLOWNERWINDOWEX64 = 88,

	ISARC_SET_ENUM_MEMBERS_PROC64 = 89,

	ISARC_CLEAR_ENUM_MEMBERS_PROC64 = 90,

	ISARC_OPEN_ARCHIVE2 = 91,

	ISARC_GET_ARC_READ_SIZE = 92,

	ISARC_GET_ARC_READ_SIZE_EX = 93,

	SET_LANGUE_JAPANESE = 94,

	SET_LANGUE_ENGLISH = 95,

	SET_LANGUE_SPECIFIED = 96,

	ISARC_SET_LANGUE_SPECIFIED = 97,

	ISARC_SET_LANGUE_JAPANESE = 98,

	ISARC_SET_LANGUE_ENGLISH = 99,

	ISARC_SET_PRIORITY = 100,

	ISARC_GET_ATTRIBUTES = 101,

	ISARC_SET_CP = 102,

	ISARC_GET_CP = 103,

	ISARC_GET_LAST_ERROR = 104,

	ISARC_GET_ARC_WRITE_TIME = 105,

	ISARC_GET_ARC_CREATE_TIME = 106,

	ISARC_GET_ARC_ACCESS_TIME = 107,

	ISARC_GET_ARC_WRITE_TIME_64 = 108,

	ISARC_GET_ARC_CREATE_TIME_64 = 109,

	ISARC_GET_ARC_ACCESS_TIME_64 = 110,

	ISARC_GET_WRITE_TIME_64 = 111,

	ISARC_GET_CREATE_TIME_64 = 112,

	ISARC_GET_ACCESS_TIME_64 = 113,

	ISARC_SET_UNICODE_MODE = 114,

	ISARC_FUNCTION_END = ISARC_SET_UNICODE_MODE,
//alias ISARC_SET_UNICODE_MODE ISARC_FUNCTION_END,
//#define	WM_ARCEXTRACT	"wm_arcextract"



	ARCEXTRACT_BEGIN = 0,

	ARCEXTRACT_INPROCESS = 1,

	ARCEXTRACT_END = 2,

	ARCEXTRACT_OPEN = 3,

	ARCEXTRACT_COPY = 4,

/* OpenArchive 系 API です。 */



	M_INIT_FILE_USE = 0x00000001,

	M_REGARDLESS_INIT_FILE = 0x00000002,

	M_NO_BACKGROUND_MODE = 0x00000004,

	M_NOT_USE_TIME_STAMP = 0x00000008,

	M_EXTRACT_REPLACE_FILE = 0x00000010,

	M_EXTRACT_NEW_FILE = 0x00000020,

	M_EXTRACT_UPDATE_FILE = 0x00000040,

	M_CHECK_ALL_PATH = 0x00000100,

	M_CHECK_FILENAME_ONLY = 0x00000200,

	M_CHECK_DISK_SIZE = 0x00000400,

	M_REGARDLESS_DISK_SIZE = 0x00000800,

	M_USE_DRIVE_LETTER = 0x00001000,

	M_NOT_USE_DRIVE_LETTER = 0x00002000,

	M_INQUIRE_DIRECTORY = 0x00004000,

	M_NOT_INQUIRE_DIRECTORY = 0x00008000,

	M_INQUIRE_WRITE = 0x00010000,

	M_NOT_INQUIRE_WRITE = 0x00020000,

	M_CHECK_READONLY = 0x00040000,

	M_REGARDLESS_READONLY = 0x00080000,

	M_REGARD_E_COMMAND = 0x00100000,

	M_REGARD_X_COMMAND = 0x00200000,

	M_ERROR_MESSAGE_ON = 0x00400000,

	M_ERROR_MESSAGE_OFF = 0x00800000,

	M_BAR_WINDOW_ON = 0x01000000,

	M_BAR_WINDOW_OFF = 0x02000000,

	M_CHECK_PATH = 0x04000000,

	M_RECOVERY_ON = 0x08000000,


	M_MAKE_INDEX_FILE = 0x10000000,

	M_NOT_MAKE_INDEX_FILE = 0x20000000,

	EXTRACT_FOUND_FILE = 0x40000000,

	EXTRACT_NAMED_FILE = 0x80000000,


	SFX_NOT = 0,


	SFX_DOS_S = 1,

	SFX_DOS_204S = 1,

	SFX_DOS_213S = 1,

	SFX_DOS_250S = 2,

	SFX_DOS_260S = 3,

	SFX_DOS_265S = 3,


	SFX_DOS_L = 51,

	SFX_DOS_204L = 51,

	SFX_DOS_213L = 51,

	SFX_DOS_250L = 52,

	SFX_DOS_260L = 53,

	SFX_DOS_265L = 53,


	SFX_DOS_LARC = 201,

	SFX_DOS_LARC_S = 201,

	SFX_DOS_LARC_L = 202,


	SFX_DOS_LHARC = 301,

	SFX_DOS_LHARC_S = 301,

	SFX_DOS_LHARC_L = 351,


	SFX_WIN16_213 = 1001,

	SFX_WIN16_213_1 = 1001,

	SFX_WIN16_213_2 = 1002,

	SFX_WIN16_213_3 = 1003,


	SFX_WIN16_250 = 1011,

	SFX_WIN16_250_1 = 1011,

	SFX_WIN16_255_1 = 1021,


	SFX_WIN32_213 = 2001,

	SFX_WIN32_213_1 = 2001,

	SFX_WIN32_213_3 = 2002,


	SFX_WIN32_214_1 = 2003,


	SFX_WIN32_250 = 2011,

	SFX_WIN32_250_1 = 2011,

	SFX_WIN32_250_6 = 2012,


	SFX_WIN32_300 = 2021,

	SFX_WIN32_300_1 = 2021,


	SFX_LZHSFX = 2051,

	SFX_LZHSFX_1002 = 2051,

	SFX_LZHSFX_1100 = 2052,


	SFX_LZHAUTO = 2101,

	SFX_LZHAUTO_0002 = 2101,

	SFX_LZHAUTO_1000 = 2102,

	SFX_LZHAUTO_1002 = 2102,

	SFX_LZHAUTO_1100 = 2103,


	SFX_WIN32_LHASA = 3001,


	SFX_DOS_UNKNOWN = 9901,

	SFX_WIN16_UNKNOWN = 9911,

	SFX_WIN32_UNKNOWN = 9921,
/* Attributes */


	FA_RDONLY = 0x01,

	FA_HIDDEN = 0x02,

	FA_SYSTEM = 0x04,

	FA_LABEL = 0x08,

	FA_DIREC = 0x10,

	FA_ARCH = 0x20,

	FA_COMPRESSED = 0x0800,

	FA_ENCRYPTED = 0x4000,


	SFXFLAG_AUTO = 0x0001,

	SFXFLAG_OVERWRITE = 0x0002,

	SFXFLAG_CHECKCRC = 0x0004,

	SFXFLAG_CHECKTIME = 0x0008,

	SFXFLAG_ATTRIBUTE = 0x0010,

	SFXFLAG_ATTRIBUTES = 0x0010,

	SFXFLAG_NO_AUTO = 0x0100,

	SFXFLAG_NO_OVERWRITE = 0x0200,

	SFXFLAG_NO_CHECKCRC = 0x0400,

	SFXFLAG_NO_CHECKTIME = 0x0800,

	SFXFLAG_NO_ATTRIBUTE = 0x1000,

	SFXFLAG_NO_ATTRIBUTES = 0x1000,

	SFXFLAG_NO_WAIT = 0x2000,


	BPL_NORMAL = 0x00,

	BPL_DENY_TOO_MANY_PARENTS = 0x01,

	BPL_DENY_ABS_PATH = 0x02,

	BPL_DENY_PARENTS = 0x04,

	BPL_DENY_EXECUTABLE = 0x08,

	BPL_DENY_CTRLCHARS = 0x10,

	BPL_DENY_LEVEL_0 = BPL_NORMAL,
//alias BPL_NORMAL BPL_DENY_LEVEL_0,




/* WARNING */
	ERROR_START = 0x8000,


	ERROR_DISK_SPACE = 0x8005,

	ERROR_READ_ONLY = 0x8006,

	ERROR_USER_SKIP = 0x8007,

	ERROR_UNKNOWN_TYPE = 0x8008,

	ERROR_METHOD = 0x8009,

	ERROR_PASSWORD_FILE = 0x800A,

	ERROR_VERSION = 0x800B,

	ERROR_FILE_CRC = 0x800C,

	ERROR_FILE_OPEN = 0x800D,

	ERROR_MORE_FRESH = 0x800E,

	ERROR_NOT_EXIST = 0x800F,

	ERROR_ALREADY_EXIST = 0x8010,


	ERROR_TOO_MANY_FILES = 0x8011,
/* ERROR */


	ERROR_MAKEDIRECTORY = 0x8012,

	ERROR_CANNOT_WRITE = 0x8013,

	ERROR_HUFFMAN_CODE = 0x8014,

	ERROR_COMMENT_HEADER = 0x8015,

	ERROR_HEADER_CRC = 0x8016,

	ERROR_HEADER_BROKEN = 0x8017,

	ERROR_ARC_FILE_OPEN = 0x8018,

	ERROR_NOT_ARC_FILE = 0x8019,

	ERROR_CANNOT_READ = 0x801A,

	ERROR_FILE_STYLE = 0x801B,

	ERROR_COMMAND_NAME = 0x801C,

	ERROR_MORE_HEAP_MEMORY = 0x801D,

	ERROR_ENOUGH_MEMORY = 0x801E,

	ERROR_ALREADY_RUNNING = 0x801F,


	ERROR_USER_CANCEL = 0x8020,

	ERROR_HARC_ISNOT_OPENED = 0x8021,

	ERROR_NOT_SEARCH_MODE = 0x8022,

	ERROR_NOT_SUPPORT = 0x8023,

	ERROR_TIME_STAMP = 0x8024,

	ERROR_TMP_OPEN = 0x8025,

	ERROR_LONG_FILE_NAME = 0x8026,

	ERROR_ARC_READ_ONLY = 0x8027,

	ERROR_SAME_NAME_FILE = 0x8028,

	ERROR_NOT_FIND_ARC_FILE = 0x8029,

	ERROR_RESPONSE_READ = 0x802A,

	ERROR_NOT_FILENAME = 0x802B,

	ERROR_TMP_COPY = 0x802C,

	ERROR_EOF = 0x802D,

	ERROR_ADD_TO_LARC = 0x802E,

	ERROR_TMP_BACK_SPACE = 0x802F,

	ERROR_SHARING = 0x8030,

	ERROR_NOT_FIND_FILE = 0x8031,

	ERROR_LOG_FILE = 0x8032,

	ERROR_NO_DEVICE = 0x8033,

	ERROR_GET_ATTRIBUTES = 0x8034,

	ERROR_SET_ATTRIBUTES = 0x8035,

	ERROR_GET_INFORMATION = 0x8036,

	ERROR_GET_POINT = 0x8037,

	ERROR_SET_POINT = 0x8038,

	ERROR_CONVERT_TIME = 0x8039,

	ERROR_GET_TIME = 0x803a,

	ERROR_SET_TIME = 0x803b,

	ERROR_CLOSE_FILE = 0x803c,

	ERROR_HEAP_MEMORY = 0x803d,

	ERROR_HANDLE = 0x803e,

	ERROR_TIME_STAMP_RANGE = 0x803f,

	ERROR_MAKE_ARCHIVE = 0x8040,

	ERROR_NOT_CONFIRM_NAME = 0x8041,

	ERROR_UNEXPECTED_EOF = 0x8042,

	ERROR_INVALID_END_MARK = 0x8043,

	ERROR_INVOLVED_LZH = 0x8044,

	ERROR_NO_END_MARK = 0x8045,

	ERROR_HDR_INVALID_SIZE = 0x8046,

	ERROR_UNKNOWN_LEVEL = 0x8047,

	ERROR_BROKEN_DATA = 0x8048,

	ERROR_INVALID_PATH = 0x8049,

	ERROR_TOO_BIG = 0x804A,

	ERROR_EXECUTABLE_FILE = 0x804B,

	ERROR_INVALID_VALUE = 0x804C,

	ERROR_HDR_EXPLOIT = 0x804D,

	ERROR_HDR_NO_CRC = 0X804E,

	ERROR_HDR_NO_NAME = 0X804F,
	ERROR_END = ERROR_HDR_NO_NAME,
//alias ERROR_HDR_NO_NAME ERROR_END,
/* ### UNLHA32.DLL 独自の API です。### */


	UNLHA_LIST_COMMAND = 1,

	UNLHA_ADD_COMMAND = 2,

	UNLHA_FRESH_COMMAND = 3,

	UNLHA_DELETE_COMMAND = 4,

	UNLHA_EXTRACT_COMMAND = 5,

	UNLHA_PRINT_COMMAND = 6,

	UNLHA_TEST_COMMAND = 7,

	UNLHA_MAKESFX_COMMAND = 8,

	UNLHA_JOINT_COMMAND = 9,

	UNLHA_CONVERT_COMMAND = 10,

	UNLHA_RENAME_COMMAND = 11,




	STID_FONTGOTICK = 101,

	STID_FONTPGOTICK = 102,

	STID_REG_STANDARD = 103,


	STID_UNLHA32DLG1 = 1001,

	STID_UNLHA32DLG2 = 1002,

	STID_UNLHA32DLG3 = 1003,

	STID_UNLHA32DLG4 = 1004,


	STID_GETFNAMEDLG = 1011,

	STID_GETCMTDLG = 1012,

	STID_GETWINSFXDLG = 1013,

	STID_UNLHA32OWDLG = 1014,

	STID_UNLHA32MKDIRDLG = 1015,


	STID_DLG_T_PROC = 1101,

	STID_DLG_P_ARCNAME = 1102,

	STID_DLG_P_FILENAME = 1103,

	STID_DLG_P_EXTRACTDIR = 1104,

	STID_DLG_P_WRITESIZE = 1105,

	STID_DLG_P_CANCEL = 1106,


	STID_DLG_T_LOCALSETTING = 1111,

	STID_DLG_P_MAKE_DIR = 1113,

	STID_DLG_P_CHK_SPACE = 1114,

	STID_DLG_P_TOTAL = 1115,

	STID_DLG_P_MINI_DLG = 1116,

	STID_DLG_P_FLUSH = 1117,

	STID_DLG_P_OLD_LOG = 1118,

	STID_DLG_P_OLD_GF = 1119,

	STID_DLG_P_OK = 1120,

	STID_DLG_P_MAPPEDFILE = 1121,


	STID_DLG_T_OWDIALOG = 1131,

	STID_DLG_P_OWGROUP = 1132,

	STID_DLG_P_OWOVWRITE = 1133,

	STID_DLG_P_OWNOTOW = 1134,

	STID_DLG_P_OWALLOW = 1135,

	STID_DLG_P_OWALLNOT = 1136,

	STID_DLG_P_BREAK = 1137,


	STID_DLG_T_CHGFNAME = 1141,

	STID_DLG_P_FNAMETITLE = 1142,


	STID_DLG_T_CDDIALOG = 1151,

	STID_DLG_P_CDCREATE = 1152,

	STID_DLG_P_CDNOTCREATE = 1153,

	STID_DLG_P_CDALLCREATE = 1154,

	STID_DLG_P_CDALLNOT = 1155,


	STID_DLG_T_CMTDIALOG = 1161,


	STID_DLG_T_WINSFXSET = 1171,

	STID_DLG_P_WSWINTITLE = 1172,

	STID_DLG_P_WSDIRTITLE = 1173,

	STID_DLG_P_WSINITDIR = 1174,

	STID_DLG_P_WSCOMMAND = 1175,

	STID_DLG_P_WSSETATTR = 1176,

	STID_DLG_P_WSSETPATH = 1177,

	STID_DLG_P_WSIGNORETIME = 1178,

	STID_DLG_P_WSAUTOOW = 1179,

	STID_DLG_P_WSAUTORUN = 1180,

	STID_DLG_P_WSTAMPERCHK = 1181,


	STID_DLG_T_SETTING = 1191,

	STID_DLG_P_SUBASEDIR = 1192,

	STID_DLG_P_SUFORCE_E = 1193,

	STID_DLG_P_SUSEL_DIR = 1194,

	STID_DLG_P_SUABS_DIR = 1195,

	STID_DLG_P_SUREL_DIR = 1196,

	STID_DLG_P_SUSEL_OW = 1197,

	STID_DLG_P_SUALW_OW = 1198,

	STID_DLG_P_SUQUE_OW = 1199,

	STID_DLG_P_SUNOT_OW = 1200,

	STID_DLG_P_SUATR_MODE = 1201,

	STID_DLG_P_SULOCAL_SET = 1202,

	STID_DLG_P_SUSAVE_ENV = 1203,

	STID_DLG_P_SUSEL_PATH = 1204,

	STID_DLG_P_SUDNY_NO = 1205,

	STID_DLG_P_SUDNY_PAR = 1206,

	STID_DLG_P_SUDNY_ABS = 1207,


	STID_DLG_T_BPDIALOG = 1211,

	STID_DLG_P_BPCHGNAME = 1212,

	STID_DLG_P_BPNOT = 1213,

	STID_DLG_P_BPALLCHG = 1214,


	STID_DLG_T_APDIALOG = 1221,

	STID_DLG_P_APRELATIVE = 1222,

	STID_DLG_P_APABS = 1223,

	STID_DLG_P_APINVALID = 1224,

	STID_DLG_T_TLDIALOG = 1225,

	STID_DLG_T_EEDIALOG = 1226,

	STID_DLG_P_EEEXTRACT = 1227,

	STID_DLG_P_EEALLEXT = 1228,


	STID_MES_T_UNLHA32_WAR = 2001,

	STID_MES_T_UNLHA32_ERR = 2002,


	STID_MES_T_PROC = 2011,

	STID_MES_T_COMPRESS = 2012,

	STID_MES_P_PROCFILE = 2013,

	STID_MES_P_ADDFILE = 2014,

	STID_MES_P_WORKFILE = 2015,


	STID_MES_P_FILECOPY = 2021,


	STID_MES_T_DELETE = 2101,

	STID_MES_P_DELETE = 2102,

	STID_MES_P_OVERWRITE = 2104,

	STID_MES_T_ROWRITE = 2105,

	STID_MES_P_ROWRITE = 2106,

	STID_MES_P_CRCCHECK = 2107,

	STID_MES_T_CRCERR = 2108,

	STID_MES_P_CRCERR = 2109,

	STID_MES_T_CRCERR2 = 2110,

	STID_MES_P_CRCERR2 = 2111,

	STID_MES_T_BADHUF = 2112,

	STID_MES_P_BADHUF = 2113,

	STID_MES_T_NAMECHANGE = 2114,

	STID_MES_P_NAMECHANGE = 2115,

	STID_MES_P_SHARE = 2116,

	STID_MES_T_MAKEDIR = 2117,

	STID_MES_P_MAKEDIR = 2118,

	STID_MES_T_CONTINUE = 2119,

	STID_MES_P_CONTINUE = 2120,

	STID_MES_T_BADARC = 2121,

	STID_MES_P_BADARC = 2122,

	STID_MES_T_CONFIRM = 2123,

	STID_MES_P_DICSIZ_WAR = 2124,

	STID_MES_P_DISKSPACE = 2125,

	STID_MES_T_SFXSET32 = 2126,

	STID_LOG_WAR_EXTDATA = 2127,

	STID_LOG_WAR_SFX = 2128,

	STID_MES_P_BADPATH = 2129,

	STID_MES_P_ABSPATH = 2130,

	STID_MES_P_TOOBIG = 2131,

	STID_MES_P_EXECUTABLE = 2132,


	STID_M_CANTOPEN = 3001,

	STID_M_MAKEDIR = 3002,

	STID_M_DIFFHOST = 3003,

	STID_M_FEXISTS = 3004,

	STID_M_FNEW = 3005,

	STID_M_FOLD = 3006,

	STID_M_FSAME = 3007,

	STID_M_FNOEXIST = 3008,

	STID_M_NOTSPCE = 3009,

	STID_M_RDONLY = 3010,

	STID_M_SPATTR = 3011,

	STID_M_USKIP = 3012,

	STID_M_WRITEER = 3013,

	STID_M_DANNAME = 3014,

	STID_M_SHARE = 3015,


	STID_M_TOOLONG = 3101,

	STID_M_TOOBIG = 3102,

	STID_M_TOOLARGE = 3102,

	STID_M_UNKNMETH = 3103,

	STID_M_BADPATH = 3104,

	STID_M_TOO_BIG2 = 3105,

	STID_M_EXEFILE = 3106,


	STID_M_ERRORCNT = 3201,

	STID_M_NOSPCL = 3202,


	STID_ERR_8005 = 9001,

	STID_ERR_8006 = 9002,

	STID_ERR_8007 = 9003,

	STID_ERR_8008 = 9004,

	STID_ERR_8009 = 9005,

	STID_ERR_800A = 9006,

	STID_ERR_800B = 9007,

	STID_ERR_800C = 9008,

	STID_ERR_800D = 9009,

	STID_ERR_800E = 9010,

	STID_ERR_800F = 9011,

	STID_ERR_8010 = 9012,

	STID_ERR_8011 = 9013,


	STID_ERR_8012 = 9014,

	STID_ERR_8013 = 9015,

	STID_ERR_8014 = 9016,

	STID_ERR_8015 = 9017,

	STID_ERR_8016 = 9018,

	STID_ERR_8017 = 9019,

	STID_ERR_8018 = 9020,

	STID_ERR_8019 = 9021,

	STID_ERR_801A = 9022,

	STID_ERR_801B = 9023,

	STID_ERR_801C = 9024,

	STID_ERR_801D = 9025,

	STID_ERR_801E = 9026,

	STID_ERR_801F = 9027,

	STID_ERR_8020 = 9028,

	STID_ERR_8021 = 9029,

	STID_ERR_8022 = 9030,

	STID_ERR_8023 = 9031,

	STID_ERR_8024 = 9032,

	STID_ERR_8025 = 9033,

	STID_ERR_8026 = 9034,

	STID_ERR_8027 = 9035,

	STID_ERR_8028 = 9036,

	STID_ERR_8029 = 9037,

	STID_ERR_802A = 9038,

	STID_ERR_802B = 9039,

	STID_ERR_802C = 9040,

	STID_ERR_802D = 9041,

	STID_ERR_802E = 9042,

	STID_ERR_802F = 9043,

	STID_ERR_8030 = 9044,

	STID_ERR_8031 = 9045,

	STID_ERR_8032 = 9046,

	STID_ERR_8033 = 9047,

	STID_ERR_8034 = 9048,

	STID_ERR_8035 = 9049,

	STID_ERR_8036 = 9050,

	STID_ERR_8037 = 9051,

	STID_ERR_8038 = 9052,

	STID_ERR_8039 = 9053,

	STID_ERR_803A = 9054,

	STID_ERR_803B = 9055,

	STID_ERR_803C = 9056,

	STID_ERR_803D = 9057,

	STID_ERR_803E = 9058,

	STID_ERR_803F = 9059,

	STID_ERR_8040 = 9060,

	STID_ERR_8041 = 9061,

	STID_ERR_8042 = 9062,

	STID_ERR_8043 = 9063,

	STID_ERR_8044 = 9064,

	STID_ERR_8045 = 9065,

	STID_ERR_8046 = 9066,

	STID_ERR_8047 = 9067,

	STID_ERR_8048 = 9068,

	STID_ERR_8049 = 9069,

	STID_ERR_804A = 9070,

	STID_ERR_804B = 9071,

	STID_ERR_804C = 9072,

	STID_ERR_804D = 9073,

	STID_ERR_804E = 9074,

	STID_ERR_804F = 9075,
}
